//*****************************************************
//**   Ivory Draw 1.0 Beta 4                         **
//**   DirectDraw component package for C++Builder   **
//*****************************************************

// (C) 1998 Tamas Demjen
// email: demjen@usa.net
// Web: http://members.xoom.com/demjen
// Ivory Draw on the Web: http://members.xoom.com/demjen/bcb/ivory.html

// This product is freeware, as described in license.txt
//---------------------------------------------------------------------------
#ifndef IvoryCanvasH
#define IvoryCanvasH

#include "IvoryError.h"
//---------------------------------------------------------------------------
class IVORY_package TCustomIvorySurface;
class IVORY_package TIvoryBitmap;

class IVORY_package TIvoryCanvas : public TPersistent
{
   friend TCustomIvorySurface;
private:
   HDC FHandle;
   TPen* FPen;
   TBrush* FBrush;
   TFont* FFont;
   TNotifyEvent FOnChanging;
   TNotifyEvent FOnChange;
protected:
   void __fastcall SetHandle(HDC handle);// { FHandle = handle; }
   void __fastcall SetPen(TPen* pen);
   void __fastcall SetBrush(TBrush* brush);
   void __fastcall SetFont(TFont* font);
   void __fastcall PenChanged(TObject* pen);
   void __fastcall BrushChanged(TObject* brush);
   void __fastcall FontChanged(TObject* font);
public:
   __fastcall TIvoryCanvas();
   virtual __fastcall ~TIvoryCanvas();
   void __fastcall Draw(int x, int y, TIvoryBitmap* bmp);
   void __fastcall Draw(int x, int y, HBITMAP bmp);
   void __fastcall MapDraw(int x, int y, TIvoryBitmap* bmp, const Windows::TRect& rect);
   void __fastcall MapDraw(int x, int y, HBITMAP bmp, const Windows::TRect& rect);
   void __fastcall StretchDraw(const Windows::TRect& Rect, TIvoryBitmap* bmp);
   void __fastcall StretchDraw(const Windows::TRect& Rect, HBITMAP bmp);
   void __fastcall TileDraw(const Windows::TRect& Rect, TIvoryBitmap* bmp);
   void __fastcall TileDraw(const Windows::TRect& Rect, HBITMAP bmp);
   void __fastcall Rectangle(int x1, int y1, int x2, int y2);
   void __fastcall Arc(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4);
   void __fastcall Chord(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4);
   void __fastcall DrawFocusRect(const TRect rect);
   void __fastcall Ellipse(int x1, int y1, int x2, int y2);
   void __fastcall FillRect(const TRect rect);
   void __fastcall FloodFill(int x, int y, TColor color, TFillStyle fillStyle);
   void __fastcall FrameRect(const TRect rect);
   void __fastcall LineTo(int x, int y);
   void __fastcall MoveTo(int x, int y);
   void __fastcall Pie(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4);
   void __fastcall RoundRect(int x1, int y1, int x2, int y2, int x3, int y3);
   int __fastcall TextHeight(const String text);
   void __fastcall TextOut(int x, int y, const String text);
   void __fastcall TextRect(TRect rect, int x, int y, const String text);
   int __fastcall TextWidth(const String text);

   __property HDC Handle = { read=FHandle };

   __property TNotifyEvent OnChanging = { read=FOnChanging, write=FOnChanging };
   __property TNotifyEvent OnChange = { read=FOnChange, write=FOnChange };
__published:
   __property TBrush* Brush = { read=FBrush, write=SetBrush };
   __property TFont* Font = { read=FFont, write=SetFont };
   __property TPen* Pen = { read=FPen, write=SetPen };
};
//---------------------------------------------------------------------------
#endif
