//*****************************************************
//**   Ivory Draw 1.0 Beta 4                         **
//**   DirectDraw component package for C++Builder   **
//*****************************************************

// (C) 1998 Tamas Demjen
// email: demjen@usa.net
// Web: http://members.xoom.com/demjen
// Ivory Draw on the Web: http://members.xoom.com/demjen/bcb/ivory.html

// This product is freeware, as described in license.txt
//---------------------------------------------------------------------------
#ifndef IvoryMapperH
#define IvoryMapperH

#include "IvoryError.h"
#include "IvoryBitmap.h"
#include "CustomIvorySurface.h"
//---------------------------------------------------------------------------
class IVORY_package TIvoryMapper : public TComponent
{
private:
// child objects
   TIvoryBitmap* FBitmap;
   TCustomIvorySurface* FBitmapSurface;
// current state
   int FTileWidth;
   int FTileHeight;
   int FTiles;
   int FTileRows;
   int FTileColumns;
// getter and setter functions
   int __fastcall GetTileRows() const;
   int __fastcall GetTileColumns() const;
   TRect __fastcall GetTileRect(int n) const;
   void __fastcall SetBitmap(TIvoryBitmap* bitmap);
   void __fastcall SetBitmapSurface(TCustomIvorySurface* bitmapsurface);
protected:
public:
// constructor
   __fastcall TIvoryMapper(Classes::TComponent* AOwner);
// destructor
   virtual __fastcall ~TIvoryMapper();
// public properties
   __property int TileRows = { read=FTileRows };
   __property int TileColumns = { read=FTileColumns };
   __property TRect TileRect[int n] = { read=GetTileRect };
__published:
// published properties
   __property int TileWidth = { read=FTileWidth, write=FTileWidth, default=0 };
   __property int TileHeight = { read=FTileHeight, write=FTileHeight, default=0 };
   __property int Tiles = { read=FTiles, write=FTiles, default=0 };
   __property TIvoryBitmap* Bitmap = { read=FBitmap, write=SetBitmap, default=NULL };
   __property TCustomIvorySurface* BitmapSurface = { read=FBitmapSurface, write=SetBitmapSurface, default=NULL };
};
//---------------------------------------------------------------------------
#endif
